<?php 

namespace Controller;

defined('ROOTPATH') OR exit('Access Denied!');

/**
 * most-viewed class
 */
class Most_viewed
{
	use MainController;

	public function index()
	{

		$limit = 10;
		$pager = new \Core\Pager($limit);
		$offset = $pager->offset;
		$data['pager'] = $pager;

		$user = new \Model\User;
		$podcast = new \Model\Podcast;

		$data['podcasters'] = $user->where(['role'=>'user']);
		
		$query = "select p.*,u.username, u.slug as user_slug from podcasts as p join users as u on u.id = p.user_id order by views desc limit $limit offset $offset";
		$data['rows'] = $podcast->query($query);

		$this->view('most-viewed',$data);
	}

}
