-- phpMyAdmin SQL Dump
-- version 5.1.1
-- https://www.phpmyadmin.net/
--
-- Host: 127.0.0.1
-- Generation Time: Apr 07, 2023 at 11:39 AM
-- Server version: 10.4.22-MariaDB
-- PHP Version: 8.1.2

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
START TRANSACTION;
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `podcast_db`
--

-- --------------------------------------------------------

--
-- Table structure for table `podcasts`
--

CREATE TABLE `podcasts` (
  `id` int(11) NOT NULL,
  `user_id` int(11) NOT NULL,
  `title` varchar(100) NOT NULL,
  `description` varchar(2048) NOT NULL,
  `date` datetime DEFAULT NULL,
  `views` int(11) NOT NULL DEFAULT 0,
  `popularity` int(11) NOT NULL DEFAULT 0,
  `slug` varchar(100) NOT NULL,
  `image` varchar(2048) DEFAULT NULL,
  `file` varchar(2048) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `podcasts`
--

INSERT INTO `podcasts` (`id`, `user_id`, `title`, `description`, `date`, `views`, `popularity`, `slug`, `image`, `file`) VALUES
(1, 1, 'my first podcast', 'some kind of description', '2023-04-06 14:16:50', 0, 0, 'my-first-podcast', 'uploads/1680783410builder-young-man-construction-uniform-safety-helmet-holding-wrench-pliers-looking-confused-with-hand-his-head-mistake-standing-blue-background_141793-140410.png', 'uploads/1680783410Ghettolink_ To the sun.mp3'),
(2, 1, 'my second podcast', 'some kind of description', '2023-04-06 14:17:49', 0, 0, 'my-second-podcast', 'uploads/1680783469candid-shot-serious-european-lady-makes-shush-gesture-keesp-index-finger-lips_273609-44692.jpg', 'uploads/1680783469Ghettolink_ To the sun.mp3'),
(3, 1, 'my third podcast', 'some kind of description', '2023-04-06 14:18:43', 12, 12, 'my-third-podcast', 'uploads/1680783523blonde-woman-posing_144627-26390.jpg', 'uploads/1680783523Ghettolink_ To the sun.mp3'),
(4, 1, 'my fifth podcast', 'some kind of description', '2023-04-06 14:19:35', 13, 13, 'my-fifth-podcast', 'uploads/1680783575happy-people-recording-social-media-podcast-with-blogging-equipment-using-vlog-station-live-broadcast-conversation-internet-channel-men-meeting-studio-record-talk-show_482257-41412.jpg', 'uploads/1680783575Ghettolink_ To the sun.mp3'),
(5, 3, 'Marys podcast', 'some kind of description', '2023-04-07 08:43:48', 0, 0, 'marys-podcast', 'uploads/1680849828medium-shot-woman-recording-podcast-indoors_23-2149446213.jpg', 'uploads/1680849828Ghettolink_ To the sun.mp3'),
(6, 3, 'Marys second podcast', 'some kind of description', '2023-04-07 08:45:46', 0, 0, 'marys-second-podcast', 'uploads/1680855922pov-asian-woman-filming-live-discussion-camera-recording-podcast-online-channel-content-creator-chatting-with-audience-broadcasting-vlog-social-media-tripod-shot_482257-41091.jpg', 'uploads/1680849945Ghettolink_ To the sun.mp3'),
(9, 1, 'My favorite podcast with guests', 'some kind of description', '2023-04-07 10:41:17', 0, 0, 'my-favorite-podcast-with-guests', 'uploads/1680856877side-view-happy-woman-doing-radio_23-2148808743.jpg', 'uploads/1680856877Ghettolink_ To the sun.mp3'),
(10, 1, 'My second favorite podcast with guests', 'some kind of description', '2023-04-07 10:42:22', 0, 0, 'my-second-favorite-podcast-with-guests', 'uploads/1680856942young-woman-making-podcast-medium-shot_23-2149386577.jpg', 'uploads/1680856942Ghettolink_ To the sun.mp3');

-- --------------------------------------------------------

--
-- Table structure for table `users`
--

CREATE TABLE `users` (
  `id` int(11) NOT NULL,
  `firstname` varchar(30) NOT NULL,
  `lastname` varchar(30) NOT NULL,
  `username` varchar(30) NOT NULL,
  `email` varchar(100) NOT NULL,
  `password` varchar(255) NOT NULL,
  `role` varchar(10) NOT NULL,
  `date` datetime DEFAULT NULL,
  `image` varchar(1024) DEFAULT NULL,
  `slug` varchar(100) DEFAULT NULL,
  `bio` varchar(2048) DEFAULT NULL,
  `podcasts` int(11) NOT NULL,
  `views` int(11) NOT NULL DEFAULT 0,
  `popularity` int(11) NOT NULL DEFAULT 0
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

--
-- Dumping data for table `users`
--

INSERT INTO `users` (`id`, `firstname`, `lastname`, `username`, `email`, `password`, `role`, `date`, `image`, `slug`, `bio`, `podcasts`, `views`, `popularity`) VALUES
(1, 'Eathorne', 'Surname', 'Eathorne', 'email@email.com', '$2y$10$A2CDWHiVVihZaLw.Gta83e0UsrIOUQss/9wF7Kw8T9B51IVGEUhYK', 'user', '2023-04-05 13:37:20', 'uploads/1680707132beautiful-happy-african-american-woman-has-surprised-joyful-expression-cannot-believe-sudden-success-dressed-casual-white-jumper_273609-43273.jpg', 'eathorne', 'this is a bio', 6, 2, 2),
(3, 'Mary', 'Phiri', 'Marylicious', 'mary@email.com', '$2y$10$5wTRSZm9bR4E8DH3c3Ku7.fT00haBtplKAcO1XjZKOULRxX6cN4Ee', 'user', '2023-04-05 17:11:29', 'uploads/1680707514beautiful-woman-portrait_144627-27921.png', 'marylicious', 'This is my bio', 2, 4, 4);

--
-- Indexes for dumped tables
--

--
-- Indexes for table `podcasts`
--
ALTER TABLE `podcasts`
  ADD PRIMARY KEY (`id`),
  ADD KEY `user_id` (`user_id`),
  ADD KEY `title` (`title`),
  ADD KEY `views` (`views`),
  ADD KEY `popularity` (`popularity`),
  ADD KEY `slug` (`slug`);

--
-- Indexes for table `users`
--
ALTER TABLE `users`
  ADD PRIMARY KEY (`id`),
  ADD KEY `email` (`email`),
  ADD KEY `username` (`username`),
  ADD KEY `podcasts` (`podcasts`),
  ADD KEY `views` (`views`),
  ADD KEY `popularity` (`popularity`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `podcasts`
--
ALTER TABLE `podcasts`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=11;

--
-- AUTO_INCREMENT for table `users`
--
ALTER TABLE `users`
  MODIFY `id` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=4;
COMMIT;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
